<!DOCTYPE html>
<html lang="en">

<head>
    <title>document</title>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/js/bootstrap.min.js"></script>
    <!-- Import style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <div class="container-fluid">
        <h1 class="text-center  mb-5 mt-5">Danh sách đăng kí </h1>
        <table id="user-table" class="table table-striped table-hover table-bordered">
            <thead>
                <tr>
                    <th>Mã người dùng </th>
                    <th>First Name</th>
                    <th>Last Name </th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody></tbody>
        </table>
    </div>

</body>
<script>
    "use strict"

    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        $(document).on("click", "#user-table .btn-detail", onDetailClick);  // khai báo nút ấn qua id 
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        "use strict"
        console.log("đã load xong thẻ body ");
        getApiAndLoadDataInTable();
    }
    // khai báo nút detail 
    function onDetailClick() {
        console.log(this);
        
        var vRowClick = $(this).closest("tr"); // xác định hàng của nút ấn trên table  nut ấn 
        var vTable = $("#user-table").DataTable();   // tạo biến đến dataTable 
        var vDataRow = vTable.row(vRowClick);  // tìm hàng này trên data table trên data table 
        console.log(vDataRow.data()); // hiển thị đối  tượng là giá trị của các hàng 
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm goi api
    function getApiAndLoadDataInTable() {
        $.ajax({
            url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
            type: "GET",
            dataType: "json",
            success: getLoadDataTable,
            error: function (paramError) {
                console.log(paramError.status);
            },
        });
    }
    // hàm load data lên table 
    function getLoadDataTable(paramRes) {
        console.log(paramRes);
        /* add JSON data vào DataTable sử dụng add trực tiếp DataTable row */
        $("#user-table").DataTable({
            columns: [                  // xếp data cho các cột 
                { data: "id" },
                { data: "firstname" },
                { data: "lastname" },
                { data: "country" },
                { data: "subject" },
                { data: "customerType" },
                { data: "registerStatus" },
                { data: "action" }
            ],
            columnDefs: [         // định dạng lại các cột  xem nên hiển thị gì 
                {
                    targets: 0,   // cột id
                    className: "text-center text-danger"
                },
                {
                    targets: 3, // cột age
                    className: "text-right"
                },
                {
                    targets: 7,
                    className: "text-center text-danger",
                    defaultContent: "<button class='btn btn-success btn-detail'>Chi tiết</button>"
                },
            ]
        });
        getInsertRowTable(paramRes);
    }
    // hàm thêm từng dòng dữ liệu vào
    function getInsertRowTable(paramRes) {
        var vTable = $("#user-table").DataTable();
        vTable.rows.add(paramRes);
        vTable.draw();
    }

</script>

</html>